// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "Dispatcher.hpp"

#include <pthread.h>	// for pthread_yield

#include "Emper.hpp"
#include "Runtime.hpp"	// for Runtime

auto Dispatcher::getDispatchLoop() -> func_t {
	return [this] { dispatchLoop(); };
}

void Dispatcher::dispatchLoopDoSleep() {
	runtime.maybeTerminateWorker();

	if constexpr (emper::WORKER_SLEEP) {
		runtime.dispatchLoopSleep();
	} else {
		pthread_yield();
	}
}
