// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Fischer
#pragma once

namespace emper::lib::sync {

template <class Lockable>
class PseudoCountingTryLock {
 private:
	Lockable lock;

 public:
	[[nodiscard]] auto try_lock() -> bool {
		lock.lock();
		return true;
	}

	[[nodiscard]] auto try_lock_or_increment() -> bool { return try_lock(); }

	auto unlock() -> uint32_t {
		lock.unlock();
		return 0;
	}
};
}	 // namespace emper::lib::sync
