// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Schmaus
#pragma once

#include "RuntimeStrategyFactory.hpp"
#include "strategies/laws/LawsStrategy.hpp"

class Runtime;

class LawsStrategyFactory : public RuntimeStrategyFactory {
 private:
	LawsStrategyFactory() = default;

 public:
	auto constructRuntimeStrategy(Runtime& runtime) -> LawsStrategy* override;

	static LawsStrategyFactory INSTANCE;
};
