// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#include "LawsStrategyStats.hpp"

#include <iostream>
#include <string>

#include "LawsStrategy.hpp"
#include "WorkerLocalData.hpp"

LawsStrategyStats::LawsStrategyStats(LawsStrategy& lawsStrategy)
		: AbstractWorkStealingStats(lawsStrategy),
			workerStats(lawsStrategy.allWorkerStats.getSnapshot()) {
	for (auto& workerStat : workerStats) {
		comulatedWorkerStats += workerStat;
	}
}

void LawsStrategyStats::print() {
	AbstractWorkStealingStats::print();

	std::cout << "total-scheduled-fibers-to-priority: "
						<< std::to_string(comulatedWorkerStats.scheduledFibersToPriority) << std::endl
						<< "total-dispatched-fibers-from-priority: "
						<< std::to_string(comulatedWorkerStats.dispatchedFibersFromPriority) << std::endl
						<< "total-dispatched-fibers-from-local: "
						<< std::to_string(comulatedWorkerStats.dispatchedFibersFromLocal) << std::endl
						<< "total-dispatched-fibers-from-hint-local: "
						<< std::to_string(comulatedWorkerStats.dispatchedFibersFromHintLocal) << std::endl
						<< "total-dispatched-fibers-from-hint-anywhere: "
						<< std::to_string(comulatedWorkerStats.dispatchedFibersFromHintAnywhere) << std::endl
						<< "total-dispatched-fibers-stolen: "
						<< std::to_string(comulatedWorkerStats.dispatchedFibersStolen) << std::endl
						<< "total-dispatched-fibers-from-anywhere-queue: "
						<< std::to_string(comulatedWorkerStats.dispatchedFibersFromAnywhereQueue) << std::endl;
}
